angular.module('app.controllers')
  .controller('freegameCtrl', function ($scope, $ionicPlatform, Profile, $ionicScrollDelegate, ItemDB, PackageDB, Utils, LEADERBOARDS, Store, Gameservice, Analytics, COLOR_PRIMARY) {

    $scope.difficulties = LEADERBOARDS.slice(0, 3);
    $scope.difficulty = $scope.difficulties[0];
    $scope.currentTab = Profile.getCurrentTab();

    $scope.items = [];
    $scope.packages = PackageDB.selectAllNotPurchased();
    $scope.purchased_packages = PackageDB.selectAllPurchased();

    $scope.currentTab = 0;
    $scope.onTabSelected = function (index) {
      $scope.currentTab = index;
      Profile.setCurrentTab(index);
      $scope.difficulty = $scope.difficulties[index];
    };


    $scope.filterState = undefined;
    $scope.setFilterState = function (newState) {
      $scope.filterState = newState;
      $scope.fab = false;
      $ionicScrollDelegate.scrollTop();
    };


    $scope.getData = function () {

      $scope.packages = PackageDB.selectAllNotPurchased();
      $scope.purchased_packages = PackageDB.selectAllPurchased();

      var items = ItemDB.selectAll();

      var newItems = {};
      for (var i = 0; i < items.length; i++) {
        if (!newItems[items[i].category]) {
          newItems[items[i].category] = [];
        }
        if (!newItems[items[i].category][items[i].packageId]) {
          newItems[items[i].category][items[i].packageId] = [];
        }
        var item = items[i];
        item.niceId = newItems[items[i].category][items[i].packageId].length + 1;
        newItems[items[i].category][items[i].packageId].push(item);
      }
      $scope.items = newItems;

    };



    $scope.$on('$ionicView.afterEnter', function (viewInfo, state) {
      $scope.getData();
      Analytics.trackView('Freegame');
    });

    $scope.$on('$ionicView.beforeEnter', function (viewInfo, state) {

      $scope.currentTab = Profile.getCurrentTab();

      if(window.isTablet){
        $scope.tablePercentage = 20;
      }else{
        $scope.tablePercentage = 33;
      }

      $ionicPlatform.registerBackButtonAction(function () {
        $scope.navigateTo('app');
      }, 600);

      if(ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString(COLOR_PRIMARY);
      }
    });


      $scope.purchase = function (pack) {
        Store.purchasePackage(pack, function () {
          pack.purchased = true;
          $scope.$apply(function () {
            $scope.getData();
          });
      });
    };

    $scope.showGame = function (item, publicName) {
      switch (item.state) {
        case 0:
        case 1:
          Utils.navigateTo('game', {id: item.id, publicName: publicName});
          break;
        case 2:
        case 3:
          Utils.navigateTo('result-freegame', {id: item.id});
          break;
        default:
          break;
      }
    };


    $scope.hideObject = Profile.getProfile().hideObject;

    $scope.toggleHeader = function (difficulty, pack) {
      $scope.hideObject = Profile.toggleHeader(difficulty, pack);
    };

    $scope.showLeaderBoard = function () {
      Gameservice.showLeaderBoard($scope.difficulty.id);
    };
  });
