angular.module('app.controllers')
  .controller('mainCtrl', function ($scope, $ionicPlatform, Profile, Utils, Analytics, THEMES) {

    var resumeableGame = undefined;
    $scope.theme = "deep-purple";

    /*
     *  Resumes the last played game
     */
    $scope.resumeGame = function () {
      if (resumeableGame) {
        $scope.navigateTo('game', {'id': resumeableGame.id});
      } else {
        Utils.showTranslatedMessage("NO_SAVEGAME_AVAILABLE");
      }
    };

    /*
     * Determinate current game of the week
     */
    $scope.navigateGameOfTheWeek = function () {
      var currentGameOfTheWeek = Utils.currentGameOfTheWeek();
      if(currentGameOfTheWeek.isFinished){
        $scope.navigateTo('result-promo', {'id': currentGameOfTheWeek.id});
      }else{
        $scope.navigateTo('game', {'id': currentGameOfTheWeek.id});
      }
    };

    /*
     * Determinate which campaign game is next
     */
    $scope.navigateCampaign = function () {
      if (Profile.getProfile().campaignFinished) {
        Utils.showTranslatedMessage("CAMPAIGN_FINISHED");
        return;
      }
      $scope.navigateTo('game', {'id': Utils.nextCampaignGame().id});
    };

    /*
     * The view is about to enter and become the active view.
     */
    $scope.$on("$ionicView.beforeEnter", function () {

      Analytics.trackView('Main');

      $ionicPlatform.ready(function () {
        if (ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString(THEMES[$scope.theme]);
        }
      });

      $ionicPlatform.registerBackButtonAction(function () {
        // TODO Ask for exit
      }, 600);

      resumeableGame = Utils.resumeableGame();
      if (resumeableGame) {
        $scope.theme = resumeableGame.theme;
      }


      $scope.rankLabel = Profile.getRankLabel();
      $scope.levelInRank = Profile.getLevelInRank();
    });

  });
