angular.module('app.controllers')
  .controller('profileCtrl', function ($scope, $state, $ionicPlatform, $ionicPopup, $translate, Gameservice, Utils, Profile, Store, Analytics, THEMES) {

    $scope.theme = "deep-purple";

    /*
     * The view is about to enter and become the active view.
     */
    $scope.$on("$ionicView.beforeEnter", function () {

      $ionicPlatform.registerBackButtonAction(function () {
        $scope.navigateTo('app');
      }, 600);

      Analytics.trackView('Profile');

      $scope.level = Profile.getLevel();
      $scope.levelInRank = Profile.getLevelInRank();
      $scope.rankLabel = Profile.getRankLabel();
      $scope.hints = Profile.getProfile().hints;


      var resumeableGame = Utils.resumeableGame();
      if(resumeableGame){
        $scope.theme = resumeableGame.theme;
      }

      if(ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString(THEMES[$scope.theme]);
      }

      $scope.level = Profile.getLevel();
    });

    $scope.showHelp = function(){
      $translate(['CANCEL', 'RULES', 'VIDEO']).then(function (translations) {
        $ionicPopup.confirm({
          cssClass: "popup-vertical-buttons",
          buttons: [
            {
              text: translations.RULES,
              onTap: function(e) {
                $state.go('tutorial');
              }
            },
            {
              text: translations.VIDEO,
              onTap: function(e) {
                $state.go('video');
              }
            },
            {
              text: translations.CANCEL
            }]
        });
      });
    }

    $scope.showAllLeaderBoards = function () {
      Gameservice.showAllLeaderBoards();
    };

    $scope.showAchievements = function () {
      Gameservice.showAchievements();
    };

    $scope.purchaseHints = function () {
      if(ionic.Platform.isIOS()) {
        $translate(['PURCHASE', 'CANCEL', 'STORE_HINTS_DESCRIPTION']).then(function (translations) {
          $ionicPopup.show({
            template: translations.STORE_HINTS_DESCRIPTION,
            buttons: [
              {text: translations.CANCEL},
              {
                text: translations.PURCHASE,
                type: 'button-positive',
                onTap: function () {
                  Store.purchaseHints(function () {
                    $scope.hints = Profile.getProfile().hints;
                  }, function (msg) {
                    // TODO Translate
                    //Utils.showMessage(msg.errorMessage);
                  });
                }
              }
            ]
          });
        });
      }else{
        Store.purchaseHints(function () {
          $scope.hints = Profile.getProfile().hints;
        }, function (msg) {
          // TODO Translate
          //Utils.showMessage(msg.errorMessage);
        });
      }
    };

    $scope.restorePurchases = function () {
      Store.restorePurchases();
    };
    });
