angular.module('app.controllers')
  .controller('resultCampaignCtrl', function ($scope, $ionicPlatform, $timeout, $stateParams, ItemDB, Profile, PackageDB, Utils, Ads, Analytics, THEMES) {

    $scope.$on('$ionicView.beforeEnter', function (viewInfo, state) {

        $ionicPlatform.registerBackButtonAction(function () {
          $scope.navigateTo('app');
        }, 600);


      Analytics.trackView('Result-campaign');

      $scope.levelInRank = Profile.getLevelInRank();
      $scope.rankLabel = Profile.getRankLabel();
      $scope.nextRank = Profile.getNextRank();
      $scope.nextRankLabel = Profile.getNextRankLabel();

      $scope.resultGame = ItemDB.selectById($stateParams.id);
      $scope.package = PackageDB.selectById($scope.resultGame.packageId);
      $scope.bgColor = THEMES[$scope.resultGame.theme];
      $scope.campaignTime = Profile.getProfile().campaignTime;
      $scope.campaignFinished = Profile.getProfile().campaignFinished;

      if(ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString($scope.bgColor);
      }

      $timeout(function(){
        Ads.showInterstitial($scope.package);
      });
    });

    $scope.close = function(){
      Utils.navigateTo('app');
    };

    /*
     * Determinate which campaign game is next
     */
    $scope.playNext = function(){
      var nextGame = Utils.nextCampaignGame();
      if(nextGame){
        $scope.navigateTo('game', {'id': nextGame.id});
      }else{
        Utils.showTranslatedMessage("CAMPAIGN_FINISHED");
      }
    };

    $scope.playAgain = function () {
      Utils.navigateTo('game', {"id": $scope.resultGame.id});
    };

  });
