angular.module('app.controllers')
  .controller('resultFreegameCtrl', function ($scope, $ionicPlatform, $timeout, $stateParams, ItemDB, PackageDB, Utils, Ads, Analytics, THEMES) {

    $scope.$on("$ionicView.beforeEnter", function () {

      $ionicPlatform.registerBackButtonAction(function () {
        $scope.navigateTo('free-game');
      }, 600);

      Analytics.trackView('Result-freegame');
      $scope.resultGame = ItemDB.selectById($stateParams.id);
      $scope.package = PackageDB.selectById($scope.resultGame.packageId);
      $scope.nextGame = Utils.getNextGame($scope.resultGame.category);
      $scope.nextGamePackage = PackageDB.selectById($scope.nextGame.packageId);
      $scope.bgColor = THEMES[$scope.resultGame.theme];
      if(ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString($scope.bgColor);
      }

      $timeout(function(){
        Ads.showInterstitial($scope.package);
      });

      });


    $scope.close = function(){
      Utils.navigateTo('free-game');
    }


    $scope.playNext = function () {
      Utils.navigateTo('game', {"id": $scope.nextGame.id, publicName: $scope.nextGamePackage.niceId + '-' + $scope.nextGame.niceId});
    };

    $scope.playAgain = function () {
      Utils.navigateTo('game', {"id": $scope.resultGame.id, publicName: $scope.resultGame.niceId});
    };
  })
;
