angular.module('app.controllers')
  .controller('resultTutorialCtrl', function ($scope, $ionicPlatform, $stateParams, ItemDB, Utils, Analytics, THEMES) {

    $scope.$on("$ionicView.beforeEnter", function () {

      $ionicPlatform.registerBackButtonAction(function () {
        $scope.navigateTo('app');
      }, 600);

      Analytics.trackView('Result-tutorial');

      // Reset tutorial in order to make it playable again
      $scope.resultGame = ItemDB.selectById($stateParams.id);
      $scope.bgColor = THEMES[$scope.resultGame.theme];

      if(ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString($scope.bgColor);
      }
    });


    $scope.$on("$ionicView.afterEnter", function () {
      $scope.resultGame.isFinished = false;
      $scope.resultGame.state = 1;
      $scope.resultGame.played = false;
      delete $scope.resultGame.savedGame;
      ItemDB.insertOrUpdate($scope.resultGame);
    });

    $scope.close = function(){
      Utils.navigateTo('app');
    };

    /*
     * Play tutorial game again
     */
    $scope.playAgain = function () {
      Utils.navigateTo('game', {"id": 'TUTORIAL'});
    };

  })
;
