angular.module('app.controllers')
  .controller('videoCtrl', function ($scope, $ionicPlatform, $ionicHistory, $translate, $sce, Analytics, COLOR_PRIMARY) {

    $scope.back = function () {
      $ionicHistory.goBack();
    }

    $scope.$on("$ionicView.beforeEnter", function () {


      $ionicPlatform.registerBackButtonAction(function () {
        $scope.back();
      }, 600);

      Analytics.trackView('Video');

      if (ionic.Platform.isAndroid()) {
        StatusBar.backgroundColorByHexString(COLOR_PRIMARY);
      }
    });

    $scope.$on("$ionicView.afterEnter", function () {


      $translate(['VIDEO_ID']).then(function (translations) {
        var player = new YT.Player('player', {
          height: '390',
          width: '640',
          videoId: translations['VIDEO_ID'],
          playerVars: {'modestbranding': 1, 'autoplay': 1, 'html5': 1, 'rel': 0, 'showinfo': 0},
          events: {
            'onReady': function (event) {
              event.target.playVideo();
            }
          }
        });
      });


    });


  });
