angular.module('app.services')
  .factory('Ads', function (Profile, Utils, $ionicPlatform, Storage, ADMOB_CONFIG) {
    var showCounter = 0;
    var hasAdMobSupport = false;


    $ionicPlatform.ready(function () {
      try{
        AdMob;
        hasAdMobSupport = true;
      }catch(e){
      }
      prepare();
    });


    var prepare = function(){
      if(!Profile.hasPurchases() && hasAdMobSupport) {
        if (ionic.Platform.isAndroid()) {
          AdMob.prepareInterstitial({
            adId: ADMOB_CONFIG.ANDROID,
            autoShow: false,
            overlap:true
          });
        }
        if (ionic.Platform.isIOS()) {
          AdMob.prepareInterstitial({
            adId: ADMOB_CONFIG.IOS,
            autoShow: false,
            overlap:true
          });
        }
      }
    }


    var Ads = {
      showInterstitial: function (gamePackage) {
        Storage.getItem('purchasedPackages', function (purchasedPackages) {
          if(purchasedPackages[gamePackage.id]){
            console.log('Paid package, skipping displaying ad')
          }else  if(Utils.previousState().indexOf('/game/') == -1){
            console.log('Not coming from a game, skipping displaying ad')
          } else if (!hasAdMobSupport) {
            console.warn('No admob support, skip displaying ad')
          }else{
            AdMob.showInterstitial();
            prepare();
          };
        });        
      }
    };
    return Ads;
  });
