angular.module('app.services')
  .factory('Gameservice', function ($ionicPlatform, $cordovaToast, $filter, $translate, Storage, ACHIEVEMENTS) {
    var isAuthed = false;

    var showMessage = function (message) {
      $cordovaToast.showLongBottom(message);
    };



    var isSupported = false;

    var getAchivementById = function (id) {
      return $filter('filter')(ACHIEVEMENTS, {id: id})[0];
    };

    var startAuth = function(){
      $ionicPlatform.ready(function () {

        try{
          gamecenter;
          isSupported = true;
        }catch(e){
        }

        if (ionic.Platform.isIOS() && isSupported) {
          gamecenter.auth(function () {
            isAuthed = true;
          }, function () {
            // TODO Translation
            //showMessage('Error during auth.');
          });
        } else if (ionic.Platform.isAndroid() && isSupported) {
          window.plugins.playGamesServices.auth(function () {
            isAuthed = true;
          }, function () {
            // TODO Translation
            //showMessage('Error during auth.');
          });
        } else {
          // TODO Translation
          //showMessage('Your platform is not supported');
        }
      });
    }

    startAuth();

    var Gameservice = {
      addPoints: function (leaderboard, score) {
        Storage.setItem(leaderboard.label + '_score', score);
        if (isAuthed) {
          if (ionic.Platform.isIOS()) {
            var data = {
              score: score,
              leaderboardId: leaderboard.id
            };
            gamecenter.submitScore(function () {
            }, function () {
            }, data);
          }
          if (ionic.Platform.isAndroid()) {
            window.plugins.playGamesServices.submitScore({
              score: score,
              leaderboardId: leaderboard.id
            }, function () {
            }, function () {
            });
          }
        }
      },

      unlockAchievement: function (id) {
        if(isAuthed) {
          if (ionic.Platform.isAndroid()) {
            window.plugins.playGamesServices.unlockAchievement({
              achievementId: id
            });
          } else if (ionic.Platform.isIOS()) {
            gamecenter.reportAchievement(function () {
            }, function () {
            }, {
              achievementId: id,
              percent: "100"
            });
          }
        }
      },

      showAchievements: function () {
        if(isAuthed) {
          if (ionic.Platform.isAndroid()) {
            window.plugins.playGamesServices.showAchievements();
          }
        }else{
          startAuth();
        }
      },

      showLeaderBoard: function (id) {
        if(isAuthed) {
          if (ionic.Platform.isAndroid()) {
            window.plugins.playGamesServices.showLeaderboard({leaderboardId: id});
          } else if (ionic.Platform.isIOS()) {
            var data = {
              leaderboardId: id
            };
            gamecenter.showLeaderboard(function () {
            }, function () {
              // TODO Translation
              showMessage('Showing leaderboard failed.');
            }, data);
          }
        }else{
          $translate('LEADERBOARD_LOGIN', { GAMESERVICE: (ionic.Platform.isAndroid())? 'Google Play' : 'Game Center' }).then(function (translated) {
            showMessage(translated);
          });
          startAuth();
        }
      },

      showAllLeaderBoards: function () {
        if(isAuthed) {
          if (ionic.Platform.isAndroid()) {
            window.plugins.playGamesServices.showAllLeaderboards();
          } else if (ionic.Platform.isIOS()) {
            this.showLeaderBoard();
          }
        }else {
          startAuth();
        }
      }
    };
    return Gameservice;
  });
