angular.module('app.services')
  .factory('LocalNotifications', function ($ionicPlatform, Storage, $translate) {
    $ionicPlatform.ready(function () {
      // prepare first monday
      var date = new Date();
      var year = date.getYear();
      var notifications = [];
      date.setHours(8, 0, 0, 0);

      // Get the first Monday in the month
      while (date.getDay() !== 1) {
        date.setDate(date.getDate() + 1);
      }

      var randomStrings = [];
      for (var i = 0; i < 12; i++) {
        randomStrings.push('NOTIFICATION_GAME_OF_THE_WEEK_' + i);
      }

      $translate(randomStrings).then(function (translatedRandomStrings) {
        console.log('translatedRandomStrings', translatedRandomStrings);
        var i = 1;
        while (date.getYear() === year || date.getYear() === year + 1) {
          var randomString = translatedRandomStrings['NOTIFICATION_GAME_OF_THE_WEEK_' + Math.floor(Math.random() * 12)];
          notifications.push({
            id: i,
            title: randomString,
            foreground: true,
            trigger: { at: new Date(date.getTime()) }
          });
          console.log(new Date(date.getTime()));
          i++;
          date.setDate(date.getDate() + 7);
        }

        try {
          console.log('schedule notifications', notifications);
          cordova.plugins.notification.local.cancelAll(function () {
            for(var i = 0; i < 20; i++){
              cordova.plugins.notification.local.schedule(notifications[i]);
            }
            console.log('Scheduled');
          });
        } catch (e) {
          console.warn('Cordova not present, skip local notification schedule');
        }
        console.log('Notifications scheduled');
      });
    });
    return {};
  });