angular.module('app.services')
  .factory('Utils', function ($rootScope, $templateCache, $cordovaToast, $filter, $translate, $window, $state, Profile, ItemDB, PackageDB) {

    var previousState = '';
    $rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
      previousState = from.url;
    });
    var Utils = {

      previousState: function(){
        return previousState;
      },

      resumeableGame: function(){
        // TODO Implement usefull logic
        var resumeGameId = Profile.getResumableGameId();
        if(!resumeGameId && !Profile.getProfile().campaignFinished){
          return Utils.nextCampaignGame();
        }
        return ItemDB.selectById(resumeGameId);
      },

      /*
      * Returns the next available campaign game
      */
      nextCampaignGame: function(){
        var level = Profile.getLevel().toString();
        return ItemDB.selectById('CAMPAIGN' + "000".substring(0, 3 - level.length) + level);
      },

      /*
      * Returns current game of the week
      */
      currentGameOfTheWeek: function(){
        var currentGameOfTheWeek = 'PROMO' + $filter('date')(new Date(), 'wwyyyy');
        return ItemDB.selectById(currentGameOfTheWeek);
      },
      
      customizeFab: function(){
        $templateCache.put('custom-fam-template.html',
          '<ul class="mfb-component--{{position}} mfb-{{effect}}"' +
          '    data-mfb-toggle="{{togglingMethod}}" data-mfb-state="{{menuState}}">' +
          '  <li class="mfb-component__wrap">' +
          '    <a ng-click="clicked()" ng-mouseenter="hovered()" ng-mouseleave="hovered()"' +
          '       ng-attr-data-mfb-label="{{label}}" class="mfb-component__button--main">' +
          '       <i class="mfb-component__main-icon--resting" style="font-size: 24px;font-family: \'Material Icons\';">{{resting}}</i>' +
          '       <i class="mfb-component__main-icon--active" style="font-size: 24px;font-family: \'Material Icons\';">{{active}}</i>' +
          '    </a>' +
          '    <ul class="mfb-component__list" ng-transclude>' +
          '    </ul>' +
          '</li>' +
          '</ul>');


        $templateCache.put('custom-fab-child-template.html',
               '<li>'
            +  '  <a class="mfb-component__button--child">'
            +  '       <i class="mfb-component__child-icon material-icons" style="font-size: 24px;">{{icon}}</i>'
            +  '       <div><p>{{label}}</p></div>'
            +  '  </a>'
            +  '</li>');
            // margin-left:50px;
      },

        showMessage: function (message) {
          try {
            $cordovaToast.showLongBottom(message);
          }catch(e){
            console.log("TOAST: " + message);
          }
        },

        showTranslatedMessage: function (key) {
          $translate(key).then(function (translated) {
            Utils.showMessage(translated);
          });
        },

        navigateTo: function (stateName, params) {
          $state.go(stateName, params);
        },

        calculateRatios: function () {
          if (ionic.Platform.isIOS() && parseFloat(device.version) < 13) {
            var ratios = {ratio: (1 / $window.devicePixelRatio)};
            if ($window.devicePixelRatio > 2) {
              ratios.ratio = 1 / 2;
            }
            ratios.innerRatio = 1 / ratios.ratio;
            return ratios;
          } else {
            return {
              ratio: 1,
              innerRatio: $window.devicePixelRatio
            }
          }
        },

        getNextGame: function (category) {
          var items = ItemDB.selectAll();
          var packages = PackageDB.selectAllPurchased();

          var categoryPackages = [];
          for(var i = 0; i < packages.length; i++){
            if(packages[i]. category === category) categoryPackages.push(packages[i]);
          }


          for (var i = 0; i < items.length; i++) {
            if (items[i].category == category && items[i].state <= 1) {
              for(var j = 0; j < categoryPackages.length; j++){
                if(items[i].path.substr(-(1 +categoryPackages[j].id.length), categoryPackages[j].id.length) == categoryPackages[j].id){
                  return items[i];
                }
              }
            }
          }
          return undefined;
        }

      }
      ;
    return Utils;
  });
