angular.module('app.controllers')
  .config(function ($stateProvider, $urlRouterProvider) {
    //$stateProvider is using for add or edit HTML view to navigation bar.
    //
    //Schema :
    //state_name(String)      : Name of state to use in application.
    //page_name(String)       : Name of page to present at localhost url.
    //cache(Bool)             : Cache of view and controller default is true. Change to false if you want page reload when application navigate back to this view.
    //html_file_path(String)  : Path of html file.
    //controller_name(String) : Name of Controller.
    //
    //Learn more about ionNavView at http://ionicframework.com/docs/api/directive/ionNavView/
    //Learn more about  AngularUI Router's at https://github.com/angular-ui/ui-router/wiki
    $stateProvider
      .state('app', {
        url: "/app",
        templateUrl: "main/main.html",
        controller: 'mainCtrl'
      })
      .state('game', {
        url: "/game/:id/:publicName",
        cache: false,
        templateUrl: "game/game.html",
        controller: 'gameCtrl'
      }).state('free-game', {
      url: "/free-game",
      templateUrl: "freegame/freegame.html",
      controller: 'freegameCtrl'
    }).state('result-campaign', {
      url: "/result-campaign/:id",
      templateUrl: "result/result.html",
      controller: 'resultCampaignCtrl'
    }).state('result-freegame', {
      url: "/result-freegame/:id",
      templateUrl: "result/result.html",
      controller: 'resultFreegameCtrl'
    }).state('result-promo', {
      url: "/result-promo/:id",
      templateUrl: "result/result.html",
      controller: 'resultPromoCtrl'
    }).state('result-tutorial', {
      url: "/result-tutorial/:id",
      templateUrl: "result/result.html",
      controller: 'resultTutorialCtrl'
    }).state('profile', {
      url: "/profile",
      templateUrl: "profile/profile.html",
      controller: 'profileCtrl'
    }).state('tutorial', {
      url: "/tutorial",
      templateUrl: "js/branding/app/tutorial/tutorial.html",
      controller: 'tutorialCtrl'
    }).state('video', {
      url: "/video",
      templateUrl: "video/video.html",
      controller: 'videoCtrl'
    });
    $urlRouterProvider.otherwise("/app");
  });
